# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline().strip())
if 1 > n or n > 1024:
	sys.exit('N out of range')
fo.write('{}\n'.format(n))

aa = [int(a) for a in fi.readline().split()]
if len(aa) != n:
	sys.exit('Invalid length of A')
if 0 > min(aa) or max(aa) > 1023:
	sys.exit('A[i] out of range')
if len(set(aa)) != n:
	sys.exit('A[i] not distinct')
fo.write('{}\n'.format(' '.join([str(a) for a in aa])))

m = int(fi.readline().strip())
if 1 > m or m > 10**6:
	sys.exit('M out of range')
fo.write('{}\n'.format(m))

bb = [int(b) for b in fi.readline().split()]
if len(bb) != m:
	sys.exit('Invalid length of B')
if 0 > min(bb) or max(bb) > 1023:
	sys.exit('B[i] out of range')
fo.write('{}\n'.format(' '.join([str(b) for b in bb])))

aa = set(aa)
bb = set(bb)
res = -1
res1 = False
res2 = False
for s in range(1024):
	cc = [b + s for b in bb]
	if min(cc) >= 0 and max(cc) <= 1023 and set(cc).isdisjoint(aa):
		res = s
		res1 = True
	cc = [b - s for b in bb]
	if min(cc) >= 0 and max(cc) <= 1023 and set(cc).isdisjoint(aa):
		res = s
		res2 = True
	if res1 or res2:
		break

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if m <= 1000 and res >= 0 and res <= 2:
		print('Subtask 1')
	else:
		print('Subtask 2')
	if res > 0 and res1 and res2:
		print('Not unique')
