#include <iostream>
#include <map>
#include <vector>
#include <list>
#include <algorithm>
using namespace std;

struct moodul {
    int x; 
    int y;
    int z;
    bool operator==(const struct moodul& m2) const{
        return (z==m2.z) && (y==m2.y) && (x==m2.x);
    }
    bool operator<(const struct moodul& m2) const{
        if (z<m2.z) return true;
        if ((z==m2.z) && (y<m2.y)) return true;        
        if ((z==m2.z) && (y==m2.y)) return (x<m2.x);
        return false;
    }
};

struct avatuduks: public moodul{
    string suund;
};

struct moodul jargmine(avatuduks au){
    struct moodul vastus=au;
    int samm=1;
    if(au.suund[1]=='-'){samm=-1;}
    if(au.suund[0]=='X'){vastus.x+=samm;}
    if(au.suund[0]=='Y'){vastus.y+=samm;}
    if(au.suund[0]=='Z'){vastus.z+=samm;}
    return vastus;
} 

int main(void){
    int u;
    map<struct moodul, vector<struct moodul> > avatud;
    cin >> u;
    for(int nr=0; nr<u; nr++){
        avatuduks au;
        vector<struct moodul> v;
        cin >> au.x >> au.y >> au.z >> au.suund;
        struct moodul sihtkoht=jargmine(au);
        avatud[au].push_back(sihtkoht);
    }
    struct moodul algus;
    cin >> algus.x >> algus.y >> algus.z;
    map<struct moodul, vector<struct moodul> > ohk;
    for(map<struct moodul, vector<struct moodul> >::iterator koht = avatud.begin(); koht != avatud.end(); ++koht){
        for(vector<struct moodul>::iterator sihtkoht=koht->second.begin();
          sihtkoht!=koht->second.end(); sihtkoht++){
              if(avatud.find(*sihtkoht)!=avatud.end()){
                 if(
                 find(avatud[*sihtkoht].begin(), avatud[*sihtkoht].end(), koht->first)!=avatud[*sihtkoht].end()){
                     ohk[koht->first].push_back(*sihtkoht);
                 }
              }
          }
    }
    list<struct moodul> puhver;
    vector<struct moodul> uuritud;
    puhver.push_back(algus);
    while(!puhver.empty()){
        struct moodul uuritav=puhver.front();
        puhver.pop_front();
        if(ohk.find(uuritav)!=ohk.end()){
           for(vector<struct moodul>::iterator koht=ohk[uuritav].begin(); koht!=ohk[uuritav].end(); koht++){
               if(find(puhver.begin(), puhver.end(), *koht)==puhver.end() &&
                  find(uuritud.begin(), uuritud.end(), *koht)==uuritud.end()){
                  puhver.push_back(*koht);       
               }
           }
        }
        uuritud.push_back(uuritav);
    }    
    sort(uuritud.begin(), uuritud.end());
    for(vector<struct moodul>::iterator leitud=uuritud.begin(); leitud!=uuritud.end(); leitud++){
        cout << leitud->x << " " << leitud->y << " " << leitud->z << endl;
    }
    return 0;
}