# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n, m = [int(_) for _ in fi.readline().split()]
if 1 > n or n > 100:
	sys.exit('N out of range')
if 1 > m or m > n:
	sys.exit('M out of range')
fo.write('{0} {1}\n'.format(n, m))

xx = [int(x) for x in fi.readline().split()]
if len(xx) != n:
	sys.exit('Invalid number of prize ranks')
if 1 > min(xx) or max(xx) > n:
	sys.exit('Prize ranks out of range')
if len(set(xx)) != n:
	sys.exit('Prize ranks not distinct')
fo.write('{0}\n'.format(' '.join([str(x) for x in xx])))

yy = [int(y) for y in fi.readline().split()]
if len(yy) != m:
	sys.exit('Invalid number of student ranks')
if 1 > min(yy) or max(yy) > n:
	sys.exit('Student ranks out of range')
if len(set(yy)) != m:
	sys.exit('Strundent ranks not distinct')
fo.write('{0}\n'.format(' '.join([str(y) for y in yy])))

fi.close()
fo.close()
