// sorteerib kiirmeetodi sarnaselt, aga laisalt ainult niipalju kui vaja

#include <iostream>
#include <vector>
#include <utility>
using namespace std;

struct node {
	int p;
	node *l, *r;
	node(int p) : p(p), l(nullptr), r(nullptr) {}
};

int n, m;
vector<int> a;
node *r = nullptr;

int part(int i1, int i2) {
	int p = i1, j = i2;
	while (p < j) {
		cout << "? " << a[p] << " " << a[p + 1] << endl;
		char x; cin >> x;
		if (x == '>') {
			swap(a[p + 1], a[p]);
			++p;
		} else {
			swap(a[p + 1], a[j]);
			--j;
		}
	}
	return p;
}

node *find(int k, node *x, int i1, int i2) {
	if (i1 < i2) {
		if (x == nullptr) {
			int p = part(i1, i2);
			x = new node(p);
		}
		if (k < x->p) {
			x->l = find(k, x->l, i1, x->p - 1);
		}
		if (k > x->p) {
			x->r = find(k, x->r, x->p + 1, i2);
		}
	}
	return x;
}

int main() {
	cin >> n >> m;
	a.resize(1 + n);
	for (int i = 1; i <= n; ++i) {
		a[i] = i;
	}
	for (int i = 1; i <= m; ++i) {
		int k; cin >> k;
		r = find(k, r, 1, n);
		cout << "! " << a[k] << endl;
	}
}
