import random

N = (0,1,1,5,10,25,50,100,250,500,1000)
L_min = (0,1,94,100,10,10,10,10,10,80,90)
L_max = (0,1,94,100,99,99,99,99,99,99,99)
C_min = (0,65,33,65,65,65,65,65,65,65,65)
C_max = (0,66,127,122,122,122,122,122,122,69,69)
C_sp = (0,1000,1000,10,10,10,10,10,10,50,50)
random.seed()


def gen_line(t):
    l_line = ""
    if t == 1:
        l_line += "A"
    elif t == 2:
        for i in range(L_min[t]):
            l_line += chr(33+i)
    else:
        if L_min[t] < L_max[t]:
            l_len = random.randrange(L_min[t], L_max[t])
        else:
            l_len = L_min[t]
        for i in range(l_len):
            if C_min[t] < C_max[t]:
                if random.randrange(1,C_sp[t]) == 1:
                    l_line += " "
                else:
                    if t >= 9:
                        l_c = random.randrange(C_min[t], C_max[t])
                        if l_c < C_max[t]-1:
                            l_c = C_min[t]
                        l_line += chr(l_c)
                    else:
                        l_line += chr(random.randrange(C_min[t], C_max[t]))
            else:
                l_line += chr(C_min[t])
    return l_line.strip()


for T in range(1,11):
    file = open("input"+str(T)+".txt","w")
    file.write(str(N[T])+"\n")
    for j in range(N[T]):
        file.write(gen_line(T)+"\n")
    file.close()

