# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline())
if 1 > n or n > 1000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

for i in range(n):
	s = fi.readline().strip()
	if 1 > len(s) or len(s) > 100:
		sys.exit('Overlong line {0}'.format(2 + i))
	for c in s:
		if ord(c) < 0x20 or ord(c) > 0x7e:
			sys.exit('Invalid character 0x{0:02x} on line'.format(ord(c), 2 + i))
	fo.write('{0}\n'.format(s))

fi.close()
fo.close()
