#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib> // for exit()
using namespace std;

#define done(r, m) { cout << r << '\n'; cerr << m << '\n'; exit(0); }

int main(int argc, const char *argv[]) {
	if (argc != 4) {
		done(0, "Usage: " << argv[0] << " input hint output");
	}

	// we don't use the input file

	ifstream hint(argv[2]);
	int count_hint;
	string shift_hint;
	hint >> count_hint >> shift_hint;

	ifstream output(argv[3]);
	if (!output) {
		done(0, "No output file");
	}
	int count_out;
	string shift_out;
	char dummy;
	output >> count_out >> shift_out;
	if (!output || output >> dummy) {
		done(0, "Invalid format");
	}

	double res = 0;
	string msg;
	if (count_out == count_hint) {
		res += 1.0/3;
	} else {
		msg = "Wrong count";
	}
	if (shift_out == shift_hint) {
		res += 2.0/3;
	} else if (msg == "") {
		msg = "Wrong shift";
	} else {
		msg += ", wrong shift";
	}
	if (msg == "") {
		msg = "OK";
	}
	done(res, msg);
}
