# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

u=int(fi.readline())
if 1 > u or u > 10000:
	sys.exit('U out of range')
fo.write('{0}\n'.format(u))

lines=[]
maxx, maxy, maxz = 0, 0, 0
for nr in range(u):
 m=fi.readline().split()
 if m in lines: sys.exit('line exists')
 lines.append(m)
 if len(m)!=4:
   sys.exit('length not 4 u {0}'.format(len(m)))
 x=int(m[0])
 y=int(m[1])
 z=int(m[2])
 maxx = max(maxx, x)
 maxy = max(maxy, y)
 maxz = max(maxz, z)
 suund=m[3]
 if 1>x or x>25: sys.exit('X out of range')
 if 1>y or y>25: sys.exit('Y out of range')
 if 1>z or z>25: sys.exit('Z out of range')
 if len(suund)!=2: sys.exit('suund wrong length')
 if suund[0] not in "XYZ": sys.exit('wrong axis')
 if suund[1] not in "+-": sys.exit('wrong direction')
 if x==1 and suund[0]=='X' and suund[1]=="-": sys.exit('out to space') 
 if y==1 and suund[0]=='Y' and suund[1]=="-": sys.exit('out to space') 
 if z==1 and suund[0]=='Z' and suund[1]=="-": sys.exit('out to space') 
 if x==25 and suund[0]=='X' and suund[1]=="+": sys.exit('out to space') 
 if y==25 and suund[0]=='Y' and suund[1]=="+": sys.exit('out to space') 
 if z==25 and suund[0]=='Z' and suund[1]=="+": sys.exit('out to space') 
 fo.write('{0} {1} {2} {3}\n'.format(x, y, z, suund))
(x, y, z)=[int(a) for a in fi.readline().split()]
maxx = max(maxx, x)
maxy = max(maxy, y)
maxz = max(maxz, z)
if 1>x or x>25: sys.exit('X out of range')
if 1>y or y>25: sys.exit('Y out of range')
if 1>z or z>25: sys.exit('Z out of range')
fo.write('{0} {1} {2}\n'.format(x, y, z))
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if maxy == 1 and maxz == 1:
		print('Subtask 1')
	elif maxz == 1:
		print('Subtask 2')
	else:
		print('Subtask 3')
