// sorteerib kõik auhinnad kiirmeetodiga ja siis hakkab päringutele vastama

#include <iostream>
#include <vector>
#include <utility>
using namespace std;

int n, m;
vector<int> a;

int part(int i1, int i2) {
	int p = i1, j = i2;
	while (p < j) {
		cout << "? " << a[p] << " " << a[p + 1] << endl;
		char x; cin >> x;
		if (x == '>') {
			swap(a[p + 1], a[p]);
			++p;
		} else {
			swap(a[p + 1], a[j]);
			--j;
		}
	}
	return p;
}

void sort(int i1, int i2) {
	if (i1 < i2) {
		int p = part(i1, i2);
		sort(i1, p - 1);
		sort(p + 1, i2);
	}
}

int main() {
	cin >> n >> m;
	a.resize(1 + n);
	for (int i = 1; i <= n; ++i) {
		a[i] = i;
	}
	for (int i = 1; i <= m; ++i) {
		int k; cin >> k;
		if (i == 1) {
			// esimese päringu ajal sorteerime kohe kõik auhinnad
			sort(1, n);
		}
		cout << "! " << a[k] << endl;
	}
}
