# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

m, n, k = [int(_) for _ in fi.readline().split()]
if 1 > m or m > 500:
	sys.exit('M out of range')
if 1 > n or n > 200:
	sys.exit('N out of range')
if 1 > k or n > 1000:
	sys.exit('K out of range')
fo.write('{0} {1} {2}\n'.format(m, n, k))

for i in range(m):
	p, w = [int(_) for _ in fi.readline().split()]
	if 1 > p or p > 1000:
		sys.exit('P[{0}] out of range'.format(1 + i))
	if 0 > w or w > 1000:
		sys.exit('W[{0}] out of range'.format(1 + i))
	fo.write('{0} {1}\n'.format(p, w))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if m == 1:
		print('Subtask 1')
	elif n == 2:
		print('Subtask 2')
	elif m <= 50:
		print('Subtask 3')
	elif m <= 100:
		print('Subtask 4')
	else:
		print('Subtask 5')
